# global conf
{
{% if caddy_debug is sameas true %}
    debug
{% endif %}

    http_port   {{ caddy_http_port }}
    https_port   {{ caddy_https_port }}
    email {{ lets_encrypt_email }}
    key_type {{ caddy_acme_keytype }}

    # required for cache directive
    # order http_cache before reverse_proxy
    # order http_cache before rewrite

{% if caddy_local_certs is sameas true %}
    local_certs
{% endif %}

{% if caddy_custom_acme_ca|length %}
    acme_ca {{ caddy_custom_acme_ca }}
{% endif %}

    # consul conf https://github.com/pteich/caddy-tlsconsul
    storage consul {
        address      "consul:8500"
        prefix       "caddytls"
        tls_enabled  "false"
        tls_insecure "true"
        token "{{ consul_acl_master_token }}"
        aes_key "{{ caddy_consul_certificates_aes_key }}"
    }
{% if caddy_security_enabled is sameas true %}

    order authenticate before respond
	order authorize before basicauth

	security {
		#local identity store localdb {
		#	realm local
		#	path /etc/caddy/users.json
		#}


		oauth identity provider keycloak {
			driver generic
			realm keycloak
			client_id {{ caddy_security_client_id }}
			client_secret {{ caddy_security_client_secret }}
			scopes openid email profile
			#required_token_fields access_token
			metadata_url {{ caddy_security_metadata_url }}

		}

		authentication portal myportal {
			crypto default token lifetime 3600
			crypto key verify {{ caddy_security_crypto_key }}

			enable identity provider keycloak
			#enable identity store localdb
			cookie domain gael-systems.com

			ui {
				logo description "Gael-Systems"
				links {
					"My Website" https://{{ caddy_security_portal_url }}/ icon "las la-home"
					#"Monitoring Grafana" https://grafana.prom.swarm.deepcube.gael-systems.com/ icon "las la-desktop"
					"My Identity" "/whoami" icon "las la-user"
			  }
			}
			transform user {
				match origin keycloak
				action add role authp/user
			}

			#transform user {
			#	match origin local
			#	action add role authp/user
			#	ui link "Portal Settings" /settings icon "las la-cog"
			#}
		}

		authorization policy mypolicy {
			set auth url https://{{ caddy_security_portal_url }}/
			allow roles authp/admin authp/user
			crypto key verify {{ caddy_security_crypto_key }}

			# enable login hint
		}
		authorization policy guests_policy {
			# disable auth redirect
			set auth url https://{{ caddy_security_portal_url }}/
			allow roles authp/admin authp/user
			crypto key verify {{ caddy_security_crypto_key }}

			acl rule {
				comment allow guests only
				match role guest authp/guest
				allow stop log info
			}
			acl rule {
				comment default deny
				match any
				deny log warn
			}
		}

		authorization policy users_policy {
			set auth url https://{{ caddy_security_portal_url }}/
			allow roles authp/admin authp/user
			crypto key verify {{ caddy_security_crypto_key }}
			
			acl rule {
				comment allow users
				match role authp/user
				allow stop log info
			}
			acl rule {
				comment default deny
				match any
				deny log warn
			}
		}

		authorization policy admins_policy {
			set auth url https://{{ caddy_security_portal_url }}/
			allow roles authp/admin authp/user
			crypto key verify {{ caddy_security_crypto_key }}

			acl rule {
				comment allow users
				match role authp/user
				allow stop log info
			}
			acl rule {
				comment default deny
				match any
				deny log warn
			}
		}

	}
}
{% endif %}

    {{ caddy_servers_directives }}

{% if caddy_security_enabled is sameas true %}

{{ caddy_security_portal_url }}:{{ caddy_https_port }} {
    header {
        Access-Control-Allow-Origin *
        Access-Control-Allow-Credentials true
        Access-Control-Allow-Methods *
        Access-Control-Allow-Headers *
        defer
    }
    route {
		header
		authenticate with myportal
    }
{% endif %}
}

:{{ caddy_metrics_port }} {
    header {
            Server ""
            X-Powered-By ""
            Referrer-Policy "same-origin"
            X-Content-Type-Options "nosniff"
            X-Frame-Options "DENY"
            X-XSS-Protection "1; mode=block"
    }

    @ipfilter {
        remote_ip {{ caddy_metrics_allowed_ips|join(' ') }} 127.0.0.1
    }

    handle @ipfilter {
        metrics "/metrics"
    }

    respond "I'm awake!" 200
}

{{ caddy_caddyfile_content }}